unit hiFrameSize;

interface

{$I share.inc}

uses Windows,Share,Kol,Messages,Win;

type
  THIFrameSize = class(THIWin)

   private
    Bmp: PBitmap;
    arrRGN: array [0..8] of HRGN; //     (      ),    
    iRGN: integer;                //      )
    resize: boolean;              //    
    oldMos, newMos: TPoint;       //       
    iHndl: integer;
    Fp: PControl;
    OldMessage: TOnMessage;

    function onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean;     
    procedure SetRegions;
    procedure ClearRegions;
    procedure ChangeSize;
   public
    _prop_BoxSize:integer;
    _prop_Position:integer;
    _prop_Color:TColor;
    _prop_ChangePosition:boolean;
    _data_Left:THI_Event;
    _data_Top:THI_Event;
    _data_Width:THI_Event;
    _data_Height:THI_Event;
    _data_Handle:THI_Event;
    _event_onStartResize:THI_Event;
    _event_onResize:THI_Event;
    _event_onFinishResize:THI_Event;

    constructor Create(Parent:PControl);
    destructor Destroy; override;
    procedure Init; override;
    procedure _work_doSet(var _Data:TData; Index:word);
    procedure _work_doClose(var _Data:TData; Index:word);
    procedure _work_doBoxSize(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doColor(var _Data:TData; Index:word);
    procedure _var_CurrentTop(var _Data:TData; Index:word);
    procedure _var_CurrentLeft(var _Data:TData; Index:word);
    procedure _var_CurrentWidth(var _Data:TData; Index:word);
    procedure _var_CurrentHeight(var _Data:TData; Index:word);
  end;

implementation

constructor THIFrameSize.Create(Parent:PControl);
begin
  inherited Create(Parent);
  Bmp := NewBitmap(0,0);
  iRGN := -1;
  resize := false;
end;

procedure THIFrameSize.Init;
begin
   Control := NewPaintbox(FParent);
   inherited;
   Control.Visible := False;
   Control.Color:= _prop_Color;

   Fp := FParent;
   OldMessage := Control.OnMessage;
   Control.OnMessage := onMessage;
end;

destructor THIFrameSize.Destroy;
begin
   Fp.OnMessage := OldMessage;
   ClearRegions;
   Bmp.Free;
   inherited;
end;

procedure THIFrameSize.ClearRegions;
var i: integer;
begin
    for i := 0 to 8 do DeleteObject(arrRGN[i]);
end;

procedure THIFrameSize.SetRegions;
var i, w2, wb, hb, h2, bs2: integer; 
begin
    ClearRegions;
    w2 := Control.Width div 2;
    h2 := Control.Height div 2;
    bs2 := _prop_BoxSize div 2; 
    wb := Control.Width - _prop_BoxSize;
    hb := Control.Height - _prop_BoxSize;
    arrRGN[0] := CreateRectRgn(wb, 0, Control.Width, _prop_BoxSize);    //  
    arrRGN[1] := CreateRectRgn(wb, h2 - bs2, Control.Width, h2 + bs2);  //  
    arrRGN[2] := CreateRectRgn(wb, hb, Control.Width, Control.Height);  //  
    arrRGN[3] := CreateRectRgn(w2 - bs2, hb, w2 + bs2, Control.Height); //  
    arrRGN[4] := CreateRectRgn(0, hb, _prop_BoxSize, Control.Height);   //  
    arrRGN[5] := CreateRectRgn(0, h2 - bs2, _prop_BoxSize, h2 + bs2);   //  
    arrRGN[6] := CreateRectRgn(0, 0, _prop_BoxSize, _prop_BoxSize);     //  
    arrRGN[7] := CreateRectRgn(w2 - bs2, 0, w2 + bs2, _prop_BoxSize);   //  
    arrRGN[8] := CreateRectRgn(0,0,0,0);
    for i := 0 to 7 do CombineRgn(arrRGN[8], arrRGN[i], arrRGN[8], RGN_OR);  
    SetWindowRgn(Control.GetWindowHandle, arrRGN[8], true);
end;

procedure THIFrameSize._work_doSet;
var rct: TRect;
    x,y: integer;
begin
    x := ReadInteger(_data,_data_Left);
    y := ReadInteger(_data,_data_Top);
    SetRect(rct, x, y, x + ReadInteger(_data,_data_Width), y + ReadInteger(_data,_data_Height));    
    iHndl := ReadInteger(_data,_data_Handle);
    case _prop_Position of
     1: InflateRect (rct, _prop_BoxSize div 2, _prop_BoxSize div 2);
     2: InflateRect (rct, _prop_BoxSize, _prop_BoxSize);
    end; 
    with Control{$ifndef F_P}^{$endif} do begin
     //MoveWindow(Handle, rct.Left, rct.Top, rct.Right - 10, rct.Bottom, true);
     BoundsRect := rct;
     BringToFront;
     Visible := True;
     SetRegions;
     Focused := true;
    end;
end;

procedure THIFrameSize.ChangeSize;
var tpos: TPoint; 
    rct: TRect;

 procedure SetWidth;
 begin
   dec(rct.Right, oldMos.X - newMos.X); 
 end;
 
 procedure SetHeight;
 begin
   dec(rct.Bottom, oldMos.Y - newMos.Y);
 end;

 procedure SetTop;
 begin
   GetCursorPos(tpos);
   ScreenToClient(Fp.Handle, tpos);
   rct.Top := tpos.y;
 end;
 
 procedure SetLeft;
 begin
   GetCursorPos(tpos);
   ScreenToClient(Fp.Handle, tpos);
   rct.Left := tpos.x;
 end;

begin
    rct := Control.BoundsRect;
    case iRGN of
     0: begin SetWidth;  SetTop;    end;
     1:       SetWidth;
     2: begin SetWidth;  SetHeight; end;
     3:       SetHeight;
     4: begin SetLeft;   SetHeight; end;
     5:       SetLeft;
     6: begin SetLeft;   SetTop;    end;
     7: SetTop;
    end;  
    //MoveWindow(Control.Handle, rct.Left, rct.Top, rct.Right - rct.Left, rct.Bottom - rct.Top, true);
    Control.BoundsRect := rct;
    oldMos := newMos;
end;

function THIFrameSize.onMessage;
const arrCursor: array [0..3] of PChar = (IDC_SIZENESW, IDC_SIZEWE, IDC_SIZENWSE, IDC_SIZENS);
var  i: integer;
     p: TPoint;
     rct: TRect;
begin
    case Msg.message of
//        WM_ENTERSIZEMOVE: ;
//        WM_PAINT: ;
        WM_SIZE:
         begin
          SetRegions;
          if resize then
           begin
            if _prop_ChangePosition and (iHndl <> 0) then
             begin
              rct := Control.BoundsRect;
              case _prop_Position of
               1: InflateRect (rct, -_prop_BoxSize div 2, -_prop_BoxSize div 2);
               2: InflateRect (rct, -_prop_BoxSize, -_prop_BoxSize);
              end; 
              SetWindowPos(iHndl, 0, rct.Left, rct.Top, rct.Right - rct.Left, rct.Bottom - rct.Top, SWP_NOZORDER); 
              //MoveWindow(iHndl, rct.Left, rct.Top, rct.Right - rct.Left, rct.Bottom - rct.Top, true);
             end;
             _hi_onEvent(_event_onResize);
           end
         end;
        WM_MOUSEMOVE: 
         if resize then
          begin
           newMos := MakePoint(Ms.X, Ms.Y);
           ChangeSize;
          end;
        WM_SETCURSOR:// if not resize then
         begin
          GetCursorPos(p);
          ScreenToClient(Control.Handle, p);
          for i := 0 to 7 do
           if PtInRegion (arrRGN[i], p.X, p.Y) then
            if i <> iRGN then
             begin
              iRGN := i;
              if i > 3 then Control.Cursor := LoadCursor(0, arrCursor[i - 4])
               else Control.Cursor := LoadCursor(0, arrCursor[i]); 
             end; 
         end;
        WM_LBUTTONDOWN: 
         begin
          resize := true;
          oldMos := MakePoint(loword(Msg.lParam), hiword(Msg.lParam));
          SetCapture(Control.Handle);
         end;
        WM_LBUTTONUP://,WM_CAPTURECHANGED: 
         if resize then
          begin
           ReleaseCapture;
           resize := false;
           _hi_onEvent(_event_onFinishResize);
          end;  
    end;    
    Result := _hi_OnMessage(OldMessage,Msg,Rslt);
end;

procedure THIFrameSize._work_doClose;
begin

end;

procedure THIFrameSize._work_doColor;
begin
    _prop_Color := ToInteger(_Data);
    Control.Color := _prop_Color;
end;

procedure THIFrameSize._work_doBoxSize;
begin
    _prop_BoxSize := ToInteger(_Data);
end;

procedure THIFrameSize._work_doPosition;
begin
    _prop_Position := ToInteger(_Data);
end;

procedure THIFrameSize._var_CurrentLeft;
begin
   case _prop_Position of
    0: dtInteger(_Data, Control.Left);
    1: dtInteger(_Data, Control.Left + _prop_BoxSize div 2);
    2: dtInteger(_Data, Control.Left + _prop_BoxSize);
   end; 
end;

procedure THIFrameSize._var_CurrentTop;
begin
   case _prop_Position of
    0: dtInteger(_Data, Control.Top);
    1: dtInteger(_Data, Control.Top + _prop_BoxSize div 2);
    2: dtInteger(_Data, Control.Top + _prop_BoxSize);
   end; 
end;

procedure THIFrameSize._var_CurrentWidth;
begin
   case _prop_Position of
    0: dtInteger(_Data, Control.Width);
    1: dtInteger(_Data, Control.Width - _prop_BoxSize);
    2: dtInteger(_Data, Control.Width - _prop_BoxSize * 2);
   end; 
end;

procedure THIFrameSize._var_CurrentHeight;
begin
   case _prop_Position of
    0: dtInteger(_Data, Control.Height);
    1: dtInteger(_Data, Control.Height - _prop_BoxSize);
    2: dtInteger(_Data, Control.Height - _prop_BoxSize * 2);
   end; 
end;

end.
